//тест моторов рисовальщика, управление с пульта (декартова система)
//36,8 шага на 1 миллиметр  сдвига по осям координат.
#include <Servo.h>
#include <IRremote.h>
//
#define plus A2 //
#define minus A1 //
// выводы для подключения модуля ULN2003 к Arduino (мотор X координаты)
#define in1 8 //
#define in2 9 //
#define in3 10 //
#define in4 11 //
// выводы для подключения модуля ULN2003 к Arduino (мотор Y координаты)
#define in11 3 //
#define in22 4 //
#define in33 5 //
#define in44 6 //

int RECV_PIN = A0;               // Pin, an den der Empf�nger angeschlossen ist
IRrecv irrecv(RECV_PIN);         // Instanz der Receiver-Klasse
decode_results results;          // Zur Aufnahme des ermittelsten Codes

int dl=3;//длительность (мс) подачи тока в фазу мотора
bool f1=1;//переменные хранения состояния фаз  мотора X (ток включен,ток отключен)
bool f2=1;//
bool f3=0;//
bool f4=0;//
bool f11=1;//переменные хранения состояния фаз  мотора Y (ток включен,ток отключен)
bool f22=1;//
bool f33=0;//
bool f44=0;//
// setup servo
int servoPin = 7;
int PEN_DOWN = 150; // angle of servo when pen is down
int PEN_UP = 60;   // angle of servo when pen is up
Servo penServo;
long Y=0;//переменная хранения моментов времени
byte FLAG=2;//

void setup() {
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);
    pinMode(in11, OUTPUT);
    pinMode(in22, OUTPUT);
    pinMode(in33, OUTPUT);
    pinMode(in44, OUTPUT);
  //
pinMode(plus,OUTPUT);//
digitalWrite(plus,HIGH);// плюс питания ик приёмника
pinMode(minus,OUTPUT);//
digitalWrite(minus,LOW);// минус питания ик приёмника
irrecv.enableIRIn(); // Startet den Receiver
  penServo.attach(servoPin);
   penServo.write(PEN_UP);  
}

void loop() {
 ///////////////////////////////////
  if (irrecv.decode(&results))   //Если произошло событие/кнопка была нажата
  {
    switch ( results.value )
    {
   //////////////////////////
    case 0x8A857://исполнить команду вперёд-по Y
  FLAG=3;Y=millis();
        break;
     case 0x88877://исполнить команду назад- по Y  
  FLAG=4;Y=millis();
        break;  
      case  0x848B7://исполнить команду вправо X
  FLAG=2;Y=millis();  
        break; 
   case  0x828D7://исполнить команду влево  X
  FLAG=1;Y=millis();    
        break;             
     case 0xFFFFFFFF:// если кнопку удерживают, то не отключать команду ещё 200 мс
      Y=millis();
        break;
   //////////////     
   case 0x8C837://кнопка OK - управление маркером
      if( penServo.read()==PEN_DOWN){ penup();}//вверх маркер
      else{
      if(penServo.read()==PEN_UP){ pendown();}//вниз маркер
      }
        break;
  /////////////////////
    case 0x8C03F://кнопка 1
     ris_1();//рисуем первый рисунок
        break;
      case 0x820DF://кнопка 2
     ris_2();//рисуем второй рисунок
        break;
     case 0x8A05F://кнопка 3
      ris_3();//рисуем третий рисунок
        break; 
     case 0x8609F://кнопка 4
      ris_4();//рисуем четвёртый рисунок
        break; 
     case 0x8E01F://кнопка 5
      ris_5();//рисуем пятый рисунок
        break; 
      case 0x810EF://кнопка 6
      ris_6();//рисуем шестой рисунок
        break; 
      case 0x8906F://кнопка 7
     ris_7();//рисуем седьмой рисунок
        break;
     case 0x850AF://кнопка 8
      ris_8();//рисуем восьмой рисунок 
        break;                                     
  }
    irrecv.resume();//Считываем следующую значение/кнопку
   }
   if(millis()-Y>200){ FLAG=0;}//если кнопка не удерживается, то через 200 мс отключить команду         
 /////////////////////////////////////////////////////
if( FLAG==2){schag_1();} 
if( FLAG==1){schag_2();}
if( FLAG==3){schag_11();} 
if( FLAG==4){schag_22();}
if( FLAG==0){stoptok();}
}
///////////////////////////////////////
void schag_1(){//шаг по часовой стрелке
 bool c=f4;f4=f3;f3=f2;f2=f1;f1=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void schag_2(){//шаг против часовой стрелки
 bool c=f1;f1=f2;f2=f3;f3=f4;f4=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void stoptok(){
 digitalWrite(in1, 0); digitalWrite(in2, 0); digitalWrite(in3, 0); digitalWrite(in4, 0);
 digitalWrite(in11, 0); digitalWrite(in22, 0); digitalWrite(in33, 0); digitalWrite(in44, 0);
 }
//////////////////////////////////////
void schag_11(){//шаг по часовой стрелке
 bool cc=f44;f44=f33;f33=f22;f22=f11;f11=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void schag_22(){//шаг против часовой стрелки
 bool cc=f11;f11=f22;f22=f33;f33=f44;f44=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void penup(){//вверх маркер
  penServo.attach(servoPin);
  for(int i=PEN_DOWN;i>=PEN_UP;i--){
  penServo.write(i);
  delay(2*dl/1);
  }
 penServo.detach(); 
}
///////////////////
void pendown(){//вниз маркер
  penServo.attach(servoPin);
for(int i=PEN_UP;i<=PEN_DOWN;i++){
  penServo.write(i);
  delay(2*dl/1);
  } 
 penServo.detach(); 
}
///////////////////////////////////////
void forward(float distance){//движение по X - увеличение координаты
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_2(); 
    } 
  }
///////////////////////////////////////
void backward(float distance){//движение по X - уменьшение координаты 
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_1(); 
    } 
  }
///////////////////////////////////////
 void left(float distance){//движение по Y - уменьшение координаты  
 int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_11(); 
    }  
 }
///////////////////////////////////////
void right(float distance){//движение по Y - увеличение координаты 
 int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_22(); 
    }  
 }
///////////////////////////////////////
void vektor(float ugol,float dlina){
  float k; int N;float Y=0;float X=0;
  ugol=ugol-360*((int)(ugol/360));//приводим значение к интервалу 0-360 если угол больше 360  
if(dlina>0&&ugol>=0&&ugol<=360){// работаем только с положительными значениями
  //
  if(ugol>=0&&ugol<=90){
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.5){forward(dlina);}if(X<0.5){right(dlina);}
  if(Y>=X){k=Y/X;N=X/0.5;}else{k=X/Y;N=Y/0.5;}
  for(int i=0;i<N;i++){
    if(Y>=X){forward(0.5);right(k*0.5);}else{forward(k*0.5);right(0.5);}
    }
    }
   //
  if(ugol>90&&ugol<=180){
  ugol=180-ugol; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.5){backward(dlina);}if(X<0.5){right(dlina);}
  if(Y>=X){k=Y/X;N=X/0.5;}else{k=X/Y;N=Y/0.5;}
  for(int i=0;i<N;i++){
    if(Y>=X){backward(0.5);right(k*0.5);}else{backward(k*0.5);right(0.5);}
    }
    }
   //
   if(ugol>180&&ugol<=270){
  ugol=ugol-180; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.5){backward(dlina);}if(X<0.5){left(dlina);}
  if(Y>=X){k=Y/X;N=X/0.5;}else{k=X/Y;N=Y/0.5;}
  for(int i=0;i<N;i++){
    if(Y>=X){backward(0.5);left(k*0.5);}else{backward(k*0.5);left(0.5);}
    }
    }
   // 
   if(ugol>270&&ugol<=360){
  ugol=360-ugol; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.5){forward(dlina);}if(X<0.5){left(dlina);}
  if(Y>=X){k=Y/X;N=X/0.5;}else{k=X/Y;N=Y/0.5;}
  for(int i=0;i<N;i++){
    if(Y>=X){forward(0.5);left(k*0.5);}else{forward(k*0.5);left(0.5);}
    }
    }
   //           
  }    
}
///////////////////////////////////////
/////////РИСУНКИ
void ris_1(){//квадраты
 forward(25);right(25);
 pendown();
 backward(50);left(50);forward(50);right(50);
 penup();
 backward(10);left(10);
 pendown();
 backward(30);left(30);forward(30);right(30);
 penup(); 
}
///////////////////////////////////////
void ris_2(){//звезда пятиконечная
 vektor(180,30); 
 pendown();
 vektor(0,30);vektor(72,30);
 vektor(288,30);vektor(0,30);
 vektor(216,30);vektor(288,30);
 vektor(144,30);vektor(216,30);
 vektor(72,30);vektor(144,30); 
 penup();  
}
///////////////////////////////////////
void ris_3(){//
 
}
///////////////////////////////////////
void ris_4(){//

}
///////////////////////////////////////
void ris_5(){//
 
}
//////////////////////////////////////
void ris_6(){//
   
}
//////////////////////////////////////
void ris_7(){//
}
//////////////////////////////////////
void ris_8(){//
}
//////////////////////////////////////

