//тест моторов рисовальщика, управление с пульта (декартова система)
//36,8 шага на 1 миллиметр  сдвига по осям координат.
#include <Servo.h>
#include <IRremote.h>
//
#define plus A2 //
#define minus A1 //
// выводы для подключения модуля ULN2003 к Arduino (мотор X координаты)
#define in1 8 //
#define in2 9 //
#define in3 10 //
#define in4 11 //
// выводы для подключения модуля ULN2003 к Arduino (мотор Y координаты)
#define in11 3 //
#define in22 4 //
#define in33 5 //
#define in44 6 //

extern char RIS_1[];
extern char RIS_2[];

int RECV_PIN = A0;               // Pin, an den der Empf�nger angeschlossen ist
IRrecv irrecv(RECV_PIN);         // Instanz der Receiver-Klasse
decode_results results;          // Zur Aufnahme des ermittelsten Codes

int dl=3;//длительность (мс) подачи тока в фазу мотора
bool f1=1;//переменные хранения состояния фаз  мотора X (ток включен,ток отключен)
bool f2=1;//
bool f3=0;//
bool f4=0;//
bool f11=1;//переменные хранения состояния фаз  мотора Y (ток включен,ток отключен)
bool f22=1;//
bool f33=0;//
bool f44=0;//
// setup servo
int servoPin = 7;
int PEN_DOWN = 150; // angle of servo when pen is down
int PEN_UP = 60;   // angle of servo when pen is up
Servo penServo;
long Y=0;//переменная хранения моментов времени
byte FLAG=2;//

void setup() {
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);
    pinMode(in11, OUTPUT);
    pinMode(in22, OUTPUT);
    pinMode(in33, OUTPUT);
    pinMode(in44, OUTPUT);
  //
pinMode(plus,OUTPUT);//
digitalWrite(plus,HIGH);// плюс питания ик приёмника
pinMode(minus,OUTPUT);//
digitalWrite(minus,LOW);// минус питания ик приёмника
irrecv.enableIRIn(); // Startet den Receiver
  penServo.attach(servoPin);
   penServo.write(PEN_UP);  
}

void loop() {
 ///////////////////////////////////
  if (irrecv.decode(&results))   //Если произошло событие/кнопка была нажата
  {
    switch ( results.value )
    {
   //////////////////////////
    case 0x8A857://исполнить команду вперёд-по Y
  FLAG=3;Y=millis();
        break;
     case 0x88877://исполнить команду назад- по Y  
  FLAG=4;Y=millis();
        break;  
      case  0x848B7://исполнить команду вправо X
  FLAG=2;Y=millis();  
        break; 
   case  0x828D7://исполнить команду влево  X
  FLAG=1;Y=millis();    
        break;             
     case 0xFFFFFFFF:// если кнопку удерживают, то не отключать команду ещё 200 мс
      Y=millis();
        break;
   //////////////     
   case 0x8C837://кнопка OK - управление маркером
      if( penServo.read()==PEN_DOWN){ penup();}//вверх маркер
      else{
      if(penServo.read()==PEN_UP){ pendown();}//вниз маркер
      }
        break;
  /////////////////////
    case 0x8C03F://кнопка 1
     ris_1();//рисуем первый рисунок
        break;
      case 0x820DF://кнопка 2
     ris_2();//рисуем второй рисунок
        break;
     case 0x8A05F://кнопка 3
      ris_3();//рисуем третий рисунок
        break; 
     case 0x8609F://кнопка 4
      ris_4();//рисуем четвёртый рисунок
        break; 
     case 0x8E01F://кнопка 5
      ris_5();//рисуем пятый рисунок
        break; 
      case 0x810EF://кнопка 6
      ris_6();//рисуем шестой рисунок
        break; 
      case 0x8906F://кнопка 7
     ris_7();//рисуем седьмой рисунок
        break;
     case 0x850AF://кнопка 8
      ris_8();//рисуем восьмой рисунок 
        break;                                     
  }
    irrecv.resume();//Считываем следующую значение/кнопку
   }
   if(millis()-Y>200){ FLAG=0;}//если кнопка не удерживается, то через 200 мс отключить команду         
 /////////////////////////////////////////////////////
if( FLAG==2){schag_1();} 
if( FLAG==1){schag_2();}
if( FLAG==3){schag_11();} 
if( FLAG==4){schag_22();}
if( FLAG==0){stoptok();}
}
///////////////////////////////////////
void schag_1(){//шаг по часовой стрелке
 bool c=f4;f4=f3;f3=f2;f2=f1;f1=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void schag_2(){//шаг против часовой стрелки
 bool c=f1;f1=f2;f2=f3;f3=f4;f4=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void stoptok(){
 digitalWrite(in1, 0); digitalWrite(in2, 0); digitalWrite(in3, 0); digitalWrite(in4, 0);
 digitalWrite(in11, 0); digitalWrite(in22, 0); digitalWrite(in33, 0); digitalWrite(in44, 0);
 }
//////////////////////////////////////
void schag_11(){//шаг по часовой стрелке
 bool cc=f44;f44=f33;f33=f22;f22=f11;f11=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void schag_22(){//шаг против часовой стрелки
 bool cc=f11;f11=f22;f22=f33;f33=f44;f44=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void penup(){//вверх маркер
  penServo.attach(servoPin);
  for(int i=PEN_DOWN;i>=PEN_UP;i--){
  penServo.write(i);
  delay(2*dl/1);
  }
 penServo.detach(); 
}
///////////////////
void pendown(){//вниз маркер
  penServo.attach(servoPin);
for(int i=PEN_UP;i<=PEN_DOWN;i++){
  penServo.write(i);
  delay(2*dl/1);
  } 
 penServo.detach(); 
}
///////////////////////////////////////
void forward(float distance){//движение по X - увеличение координаты
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_2(); 
    } 
  }
///////////////////////////////////////
void backward(float distance){//движение по X - уменьшение координаты 
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_1(); 
    } 
  }
///////////////////////////////////////
 void left(float distance){//движение по Y - уменьшение координаты  
 int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_11(); 
    }  
 }
///////////////////////////////////////
void right(float distance){//движение по Y - увеличение координаты 
 int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_22(); 
    }  
 }
///////////////////////////////////////
void vektor(float ugol,float dlina){
  //dlina=dlina/1.5;
  float k; int N;float Y=0;float X=0;
  ugol=ugol-360*((int)(ugol/360));//приводим значение к интервалу 0-360 если угол больше 360  
if(dlina>0&&ugol>=0&&ugol<=360){// работаем только с положительными значениями
  //
  if(ugol>=0&&ugol<=90){
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.25){forward(dlina);}if(X<0.25){right(dlina);}
  if(Y>=X){k=Y/X;N=X/0.25;}else{k=X/Y;N=Y/0.25;}
  for(int i=0;i<N;i++){
    if(Y>=X){forward(0.25);right(k*0.25);}else{forward(k*0.25);right(0.25);}
    }
    }
   //
  if(ugol>90&&ugol<=180){
  ugol=180-ugol; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.25){backward(dlina);}if(X<0.25){right(dlina);}
  if(Y>=X){k=Y/X;N=X/0.25;}else{k=X/Y;N=Y/0.25;}
  for(int i=0;i<N;i++){
    if(Y>=X){backward(0.25);right(k*0.25);}else{backward(k*0.25);right(0.25);}
    }
    }
   //
   if(ugol>180&&ugol<=270){
  ugol=ugol-180; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.25){backward(dlina);}if(X<0.25){left(dlina);}
  if(Y>=X){k=Y/X;N=X/0.25;}else{k=X/Y;N=Y/0.25;}
  for(int i=0;i<N;i++){
    if(Y>=X){backward(0.25);left(k*0.25);}else{backward(k*0.25);left(0.25);}
    }
    }
   // 
   if(ugol>270&&ugol<=360){
  ugol=360-ugol; 
   Y=dlina*sin(ugol*2*3.14/360); X=dlina*cos(ugol*2*3.14/360);
  if(Y<0.25){forward(dlina);}if(X<0.25){left(dlina);}
  if(Y>=X){k=Y/X;N=X/0.25;}else{k=X/Y;N=Y/0.25;}
  for(int i=0;i<N;i++){
    if(Y>=X){forward(0.25);left(k*0.25);}else{forward(k*0.25);left(0.25);}
    }
    }
   //           
  }    
}
///////////////////////////////////////
/////////РИСУНКИ
void ris_1(){//квадраты
 forward(25);right(25);
 pendown();
 backward(50);left(50);forward(50);right(50);
 penup();
 backward(10);left(10);
 pendown();
 backward(30);left(30);forward(30);right(30);
 penup(); 
}
///////////////////////////////////////
void ris_2(){//звезда пятиконечная
 vektor(180,30); 
 pendown();
 vektor(0,30);vektor(72,30);
 vektor(288,30);vektor(0,30);
 vektor(216,30);vektor(288,30);
 vektor(144,30);vektor(216,30);
 vektor(72,30);vektor(144,30);
 penup();  
}
///////////////////////////////////////
void ris_3(){//птичка
vektor(416,11);
pendown();
vektor(416,10);
vektor(413,6);
vektor(376,6);
vektor(339,6);
vektor(318,5);
vektor(348,14);
vektor(182,16);
vektor(213,7);
vektor(240,9);
vektor(244,13);
vektor(209,17);
vektor(221,9);
vektor(254,8);
vektor(279,9);
vektor(415,8);
vektor(374,6);
vektor(292,7);
vektor(447,22);
vektor(93,13);
vektor(112,13);
vektor(111,16);
vektor(104,14);
vektor(327,12);
vektor(305,11);
vektor(280,5);
vektor(223,4);
vektor(174,52);
vektor(315,13);
vektor(331,13);
vektor(349,12);
vektor(367,11);
penup();
vektor(448,49);
}
///////////////////////////////////////
void ris_4(){//волк
vektor(394,27);
pendown();
vektor(376,6);
vektor(350,6);
vektor(326,4);
vektor(273,4);
vektor(200,4);
vektor(147,4);
vektor(97,4);
vektor(418,14);
vektor(260,8);
vektor(325,6);
vektor(317,4);
vektor(262,4);
vektor(327,9);
vektor(230,7);//
vektor(172,7);
vektor(183,6);
vektor(206,6);
vektor(213,10);
vektor(222,10);
vektor(230,13);
vektor(428,22);
vektor(443,9);
vektor(119,6);
vektor(201,5);
vektor(249,6);
vektor(283,8);
vektor(326,9);
vektor(326,6);
vektor(309,5);
vektor(270,6);
vektor(420,5);
vektor(94,6);
vektor(126,5);
vektor(154,4);
vektor(407,10);
vektor(443,7);
vektor(133,5);
vektor(151,8);
vektor(185,9);
vektor(189,10);
vektor(173,10);
vektor(165,10);
vektor(149,8);
vektor(115,12);
vektor(272,6);
vektor(294,6);
vektor(313,7);
vektor(325,9);
vektor(297,6);
vektor(257,6);
vektor(211,8);
vektor(208,11);
vektor(212,8);
vektor(230,10);
vektor(431,13);
vektor(396,7);
vektor(422,8);
vektor(408,10);
vektor(380,8);
vektor(366,7);
vektor(346,6);
vektor(309,5);
vektor(250,7);
vektor(221,8);
vektor(213,9);
vektor(316,17);
vektor(161,12);
penup();  
}
///////////////////////////////////////
void ris_5(){//кролик
vektor(341,30);
pendown();
vektor(172,9);
vektor(190,10);
vektor(224,7);
vektor(275,7);
vektor(308,8);
vektor(322,7);
vektor(190,7);
vektor(227,5);
vektor(303,4);
vektor(363,25);
vektor(394,9);
vektor(438,8);
vektor(384,4);
vektor(315,4);
vektor(272,5);
vektor(207,5);
vektor(116,6);
vektor(96,12);
vektor(118,16);
vektor(148,17);
vektor(167,20);
vektor(182,11);
vektor(111,5);
vektor(427,14);
vektor(438,12);
vektor(107,5);
vektor(198,4);
vektor(236,16);
vektor(449,14);
vektor(169,2);
vektor(241,5);
vektor(262,17);
vektor(223,7);
vektor(219,8);
vektor(243,8);
vektor(278,6);
vektor(334,8);
vektor(350,10);
vektor(385,8);
vektor(430,7);
vektor(132,8);
vektor(202,8);
vektor(232,7);
vektor(261,11);
vektor(292,10);
vektor(313,7);
vektor(324,8);
vektor(220,7);
vektor(239,6);
vektor(360,14);
vektor(402,6);
vektor(416,5);
vektor(349,9);
penup();
vektor(91,35);
}
//////////////////////////////////////
void ris_6(){//кошка
vektor(260,24);
//метка
pendown();
vektor(312,4);
vektor(357,5);
vektor(399,6);
vektor(173,4);
vektor(154,7);
vektor(383,4);
vektor(428,3);
vektor(200,5);//
vektor(160,4);
vektor(210,5);
vektor(173,5);
vektor(146,3);
vektor(240,5);
vektor(282,6);
vektor(300,5);
vektor(322,6);
vektor(353,4);
vektor(389,3);
//метка
vektor(176,4);
vektor(214,7);
vektor(215,13);
vektor(197,11);
vektor(180,7);
vektor(420,5);
vektor(357,5);
vektor(343,7);
vektor(360,11);
vektor(369,12);
vektor(395,17);
vektor(429,12);
vektor(445,22);
vektor(426,9);
vektor(391,8);
vektor(364,7);
vektor(318,6);
vektor(285,6);
vektor(249,10);
vektor(235,47);
vektor(402,21);
vektor(410,11);
vektor(447,3);
vektor(168,7);
vektor(165,6);
vektor(93,7);
vektor(421,12);
vektor(412,19);
vektor(436,13);
vektor(106,12);
vektor(143,12);
vektor(182,10);
vektor(224,10);
vektor(282,8);
vektor(345,6);
vektor(399,6);
penup();
vektor(237,42);
}
//////////////////////////////////////
void ris_7(){//функция-пример точечного рисования картинки по фото (отрисовка с верхнего левого угла)
byte BYTE;  
PEN_UP = 120;//уменьшаем высоту подъёма пера над бумагой
//
for(int k3=0;k3<896;k3++){//перебираем в цикле все байты из массива картинки
if(k3%8==0){left(1.0);backward(62.6);}//после каждого восьмого байта возвращаем перо на начало новой строки (размер картинки 64*112) 
BYTE=pgm_read_byte(&RIS_1[k3]);// пишем в переменную значение текущего байта картинки 
for(int j3=7;j3>=0;j3--){//перебираем каждый бит в текущем байте
forward(1.0);//шаг между точками  
if(bitRead(BYTE,j3)==1){pendown();delay(125);penup();}//если бит равен 1 рисуем точку
}
}
//
PEN_UP = 60;//возвращаем высоту к прежнему значению
}
//////////////////////////////////////
void ris_8(){//функция-пример точечного рисования "пиксельной картинки" 
 byte BYTE;bool FL=false;  
PEN_UP = 120;//уменьшаем высоту подъёма пера над бумагой
//
for(int k3=0;k3<392;k3++){//перебираем в цикле все байты из массива картинки
if(k3%7==0){ if( penServo.read()==PEN_DOWN){ penup();}left(1.0);backward(54.8);}//после каждого седьмого байта возвращаем перо на начало новой строки (размер картинки 56*56) 
BYTE=pgm_read_byte(&RIS_2[k3]);// пишем в переменную значение текущего байта картинки 
for(int j3=7;j3>=0;j3--){//перебираем каждый бит в текущем байте
forward(1.0);//шаг между точками  
//if(bitRead(BYTE,j3)==1){pendown();delay(10);penup();}//если бит равен 1 рисуем точку
if(bitRead(BYTE,j3)==1&&!FL){FL=!FL;pendown();delay(10);}if(bitRead(BYTE,j3)==0&&FL){FL=!FL;penup();delay(10);}//если смена значения бита, то и смена состояния пера
}
}
//
PEN_UP = 60;//возвращаем высоту к прежнему значению 
}
//////////////////////////////////////
void ris_9(){//плотность точек - тест
 byte BYTE;  
PEN_UP = 120;//уменьшаем высоту подъёма пера над бумагой
//
for(int i=0;i<9;i++){
 left(0.7);backward(6.0); 
 for(int i1=0;i1<9;i1++){
 forward(0.7);
 pendown();delay(10);penup(); 
} 
}
right(7.0);forward(12);
for(int i=0;i<9;i++){
 left(1.0);backward(8.7); 
 for(int i1=0;i1<9;i1++){
 forward(1.0);
 pendown();delay(10);penup(); 
} 
}
right(9.0);forward(15);
for(int i=0;i<9;i++){
 left(1.5);backward(13.4); 
 for(int i1=0;i1<9;i1++){
 forward(1.5);
 pendown();delay(10);penup(); 
} 
}
//
PEN_UP = 60;//возвращаем высоту к прежнему значению 
}
//////////////////////////////////////
