//тест моторов рисовальщика, управление с пульта
//5,69 шага мотора на 1 градус поворота стола и 36,8 шага на 1 миллиметр радиального сдвига.
#include <Servo.h>
#include <IRremote.h>
//
#define plus A2 //
#define minus A1 //
// выводы для подключения модуля ULN2003 к Arduino (мотор радиальной координаты)
#define in1 8 //
#define in2 9 //
#define in3 10 //
#define in4 11 //
// выводы для подключения модуля ULN2003 к Arduino (мотор угловой координаты)
#define in11 3 //
#define in22 4 //
#define in33 5 //
#define in44 6 //

int RECV_PIN = A0;               // Pin, an den der Empf�nger angeschlossen ist
IRrecv irrecv(RECV_PIN);         // Instanz der Receiver-Klasse
decode_results results;          // Zur Aufnahme des ermittelsten Codes

int dl=3;//длительность (мс) подачи тока в фазу мотора
bool f1=1;//переменные хранения состояния фаз радиального мотора (ток включен,ток отключен)
bool f2=1;//
bool f3=0;//
bool f4=0;//
bool f11=1;//переменные хранения состояния фаз углового мотора (ток включен,ток отключен)
bool f22=1;//
bool f33=0;//
bool f44=0;//
// setup servo
int servoPin = 7;
int PEN_DOWN = 150; // angle of servo when pen is down
int PEN_UP = 60;   // angle of servo when pen is up
Servo penServo;
long Y=0;//переменная хранения моментов времени
byte FLAG=2;//

void setup() {
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);
    pinMode(in11, OUTPUT);
    pinMode(in22, OUTPUT);
    pinMode(in33, OUTPUT);
    pinMode(in44, OUTPUT);
  //
pinMode(plus,OUTPUT);//
digitalWrite(plus,HIGH);// плюс питания ик приёмника
pinMode(minus,OUTPUT);//
digitalWrite(minus,LOW);// минус питания ик приёмника
irrecv.enableIRIn(); // Startet den Receiver
  penServo.attach(servoPin);
   penServo.write(PEN_UP);  
}

void loop() {
 ///////////////////////////////////
  if (irrecv.decode(&results))   //Если произошло событие/кнопка была нажата
  {
    switch ( results.value )
    {
   //////////////////////////
    case 0x8A857://исполнить команду вперёд-по часовой (угол)
  FLAG=3;Y=millis();
        break;
     case 0x88877://исполнить команду назад-против часовой  (угол)
  FLAG=4;Y=millis();
        break;  
      case  0x848B7://исполнить команду вправо (радиус)
  FLAG=2;Y=millis();  
        break; 
   case  0x828D7://исполнить команду влево  (радиус)
  FLAG=1;Y=millis();    
        break;             
     case 0xFFFFFFFF:// если кнопку удерживают, то не отключать команду ещё 200 мс
      Y=millis();
        break;
   //////////////     
   case 0x8C837://кнопка OK - управление маркером
      if( penServo.read()==PEN_DOWN){ penup();}//вверх маркер
      else{
      if(penServo.read()==PEN_UP){ pendown();}//вниз маркер
      }
        break;
  /////////////////////
    case 0x8C03F://кнопка 1
     ris_1();//рисуем первый рисунок
        break;
      case 0x820DF://кнопка 2
     ris_2();//рисуем второй рисунок
        break;
     case 0x8A05F://кнопка 3
      ris_3();//рисуем третий рисунок
        break; 
     case 0x8609F://кнопка 4
      ris_4();//рисуем четвёртый рисунок
        break; 
     case 0x8E01F://кнопка 5
      ris_5();//рисуем пятый рисунок
        break; 
      case 0x810EF://кнопка 6
      ris_6();//рисуем шестой рисунок
        break;                                 
  }
    irrecv.resume();//Считываем следующую значение/кнопку
   }
   if(millis()-Y>200){ FLAG=0;}//если кнопка не удерживается, то через 200 мс отключить команду         
 /////////////////////////////////////////////////////
if( FLAG==2){schag_1();} 
if( FLAG==1){schag_2();}
if( FLAG==3){schag_11();} 
if( FLAG==4){schag_22();}
if( FLAG==0){stoptok();}
}
///////////////////////////////////////
void schag_1(){//шаг по часовой стрелке
 bool c=f4;f4=f3;f3=f2;f2=f1;f1=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void schag_2(){//шаг против часовой стрелки
 bool c=f1;f1=f2;f2=f3;f3=f4;f4=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 delay(dl);
}
//////////////////////////////////////
void stoptok(){
 digitalWrite(in1, 0); digitalWrite(in2, 0); digitalWrite(in3, 0); digitalWrite(in4, 0);
 digitalWrite(in11, 0); digitalWrite(in22, 0); digitalWrite(in33, 0); digitalWrite(in44, 0);
 }
//////////////////////////////////////
void schag_11(){//шаг по часовой стрелке
 bool cc=f44;f44=f33;f33=f22;f22=f11;f11=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void schag_22(){//шаг против часовой стрелки
 bool cc=f11;f11=f22;f22=f33;f33=f44;f44=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 delay(dl);
}
//////////////////////////////////////
void penup(){//вверх маркер
  penServo.attach(servoPin);
  for(int i=PEN_DOWN;i>=PEN_UP;i--){
  penServo.write(i);
  delay(2*dl/1);
  }
 penServo.detach(); 
}
///////////////////
void pendown(){//вниз маркер
  penServo.attach(servoPin);
for(int i=PEN_UP;i<=PEN_DOWN;i++){
  penServo.write(i);
  delay(2*dl/1);
  } 
 penServo.detach(); 
}
///////////////////////////////////////
void forward(float distance){//движение по радиусу от центра
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_2(); 
    } 
  }
///////////////////////////////////////
void backward(float distance){//движение по радиусу к центру
  int steps =distance*36.8;
  for(int step_=0; step_<steps; step_++){
    schag_1(); 
    } 
  }
///////////////////////////////////////
 void left(float degrees_){ 
 int steps =degrees_*5.69;
  for(int step_=0; step_<steps; step_++){
    schag_11(); 
    }  
 }
///////////////////////////////////////
void right(float degrees_){ 
 int steps =degrees_*5.69;
  for(int step_=0; step_<steps; step_++){
    schag_22(); 
    }  
 }
///////////////////////////////////////
/////////РИСУНКИ
void ris_1(){//шестерёнка
 forward(30);
 pendown();
 for(int i=0;i<16;i++){
 right(11.25);
 forward(10);
 right(11.25);
 backward(10);
 }
 penup(); 
 backward(10);
 pendown();
 right(360);
 penup(); 
}
///////////////////////////////////////
void ris_2(){//прибор
 pendown();
 forward(55);
 penup();
 backward(40);
 pendown();
 right(360);
 penup();
 forward(50);
 pendown();
 left(50);
 backward(40);
 right(120);
 forward(40);
 left(70);
 penup();
 backward(7); left(35);
for(int i=0;i<14;i++){
pendown();backward(12); penup(); right(7.5);forward(12);  
}
backward(25);right(15);pendown();right(220); penup(); 
}
///////////////////////////////////////
void ris_3(){//греческий узор
 forward(40);pendown();
for(int i=0;i<20;i++){
 right(11.25);backward(7);
 left(9);backward(6);
 right(15.75);forward(13);
 }
 penup();
 forward(3);pendown(); right(360);
 penup();
 backward(19);pendown(); right(360);
 penup(); 
}
///////////////////////////////////////
void ris_4(){//пятиконечная звезда 3 раза
forward(50);  
for(int i2=0;i2<3;i2++){   
backward(5);pendown();
for(int i=0;i<5;i++){ 
for(int i1=0;i1<12;i1++){
backward(2);right(3);   
}
for(int i1=0;i1<12;i1++){
forward(2);right(3);   
}    
}
penup();delay(5000);//пауза для возможности смены маркера-фломастера
}
}
///////////////////////////////////////
void ris_5(){//диск пила 8 зубьев
forward(15);pendown();
for(int i=0;i<8;i++){
for(int i1=0;i1<20;i1++){
forward(2.5);right(3.70);   
}
for(int i1=0;i1<20;i1++){
backward(2.5);left(1.5);   
}
}
penup();backward(5);pendown();right(360);penup();      
}
//////////////////////////////////////
void ris_6(){//цветок 6 лепестков
forward(35);
for(int i=0;i<7;i++){
pendown();  
for(int i1=0;i1<20;i1++){
forward(1.5);right(1.5);   
}
for(int i1=0;i1<20;i1++){
backward(1.5);right(1.5);   
}
for(int i1=0;i1<20;i1++){
backward(1.5);left(1.5);   
}
for(int i1=0;i1<20;i1++){
forward(1.5);left(1.5);   
}
penup();right(51.4);
}
delay(5000);//пауза для возможности смены маркера-фломастера
backward(20);pendown();right(360);penup();
backward(5);pendown();right(360);penup();
backward(5);pendown();right(360);penup();   
}
//////////////////////////////////////
