//тест моторов плоттера, управление с пульта
//36,8 шага на 1 миллиметр сдвига. Поле рисования 120мм*120мм, картинки 120*120 пикселей, изменение координат на 1 пиксель 14,11 единиц.
// Так получаем переводной коэффициент 2.608 шага на 1 изменения координаты.
#include <Servo.h>
#include <IRremote.h>
//
#define plus A2 //
#define minus A1 //
// выводы для подключения модуля ULN2003 к Arduino (мотор X координаты)
#define in1 8 //
#define in2 9 //
#define in3 10 //
#define in4 11 //
// выводы для подключения модуля ULN2003 к Arduino (мотор Y координаты)
#define in11 3 //
#define in22 4 //
#define in33 5 //
#define in44 6 //

int RECV_PIN = A0;               // Pin, an den der Empf�nger angeschlossen ist
IRrecv irrecv(RECV_PIN);         // Instanz der Receiver-Klasse
decode_results results;          // Zur Aufnahme des ermittelsten Codes

int dl=3;//длительность (мс) подачи тока в фазу мотора
bool f1=1;//переменные хранения состояния фаз радиального мотора (ток включен,ток отключен)
bool f2=1;//
bool f3=0;//
bool f4=0;//
bool f11=1;//переменные хранения состояния фаз углового мотора (ток включен,ток отключен)
bool f22=1;//
bool f33=0;//
bool f44=0;//
// setup servo
int servoPin = 7;
int PEN_DOWN = 150; // angle of servo when pen is down
int PEN_UP = 60;   // angle of servo when pen is up
Servo penServo;
long Y=0;//переменная хранения моментов времени
byte FLAG=2;//
int X1=0;int Y1=0;//
 
void setup() {
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);
    pinMode(in11, OUTPUT);
    pinMode(in22, OUTPUT);
    pinMode(in33, OUTPUT);
    pinMode(in44, OUTPUT);
  //
pinMode(plus,OUTPUT);//
digitalWrite(plus,HIGH);// плюс питания ик приёмника
pinMode(minus,OUTPUT);//
digitalWrite(minus,LOW);// минус питания ик приёмника
irrecv.enableIRIn(); // Startet den Receiver
  penServo.attach(servoPin);
   penServo.write(PEN_UP);  
}

void loop() {
 ///////////////////////////////////
  if (irrecv.decode(&results))   //Если произошло событие/кнопка была нажата
  {
    switch ( results.value )
    {
   //////////////////////////
    case 0x8A857://исполнить команду вперёд-по часовой (угол)
  FLAG=3;Y=millis();
        break;
     case 0x88877://исполнить команду назад-против часовой  (угол)
  FLAG=4;Y=millis();
        break;  
      case  0x848B7://исполнить команду вправо (радиус)
  FLAG=2;Y=millis();  
        break; 
   case  0x828D7://исполнить команду влево  (радиус)
  FLAG=1;Y=millis();    
        break;             
     case 0xFFFFFFFF:// если кнопку удерживают, то не отключать команду ещё 200 мс
      Y=millis();
        break;
   //////////////     
   case 0x8C837://кнопка OK - управление маркером
      if( penServo.read()==PEN_DOWN){ penup();}//вверх маркер
      else{
      if(penServo.read()==PEN_UP){ pendown();}//вниз маркер
      }
        break;
  /////////////////////
    case 0x8C03F://кнопка 1
         ris_1();
        //ris_9();
        break;
      case 0x820DF://кнопка 2
        ris_2();
        break;
     case 0x8A05F://кнопка 3
        ris_3();
        break;  
      case 0x8609F://кнопка 4
      ris_4();//рисуем четвёртый рисунок
        break; 
     case 0x8E01F://кнопка 5
      ris_5();//рисуем пятый рисунок
        break; 
      case 0x810EF://кнопка 6
      ris_6();//рисуем шестой рисунок
        break; 
      case 0x8906F://кнопка 7
      // ris_7();//рисуем седьмой рисунок
        break;
     case 0x850AF://кнопка 8
         ris_8();//рисуем восьмой рисунок 
        break;                                                                 
  }
    irrecv.resume();//Считываем следующую значение/кнопку
   }
   if(millis()-Y>200){ FLAG=0;}//если кнопка не удерживается, то через 200 мс отключить команду         
 /////////////////////////////////////////////////////
if( FLAG==2){schag_1(); delay(dl);} 
if( FLAG==1){schag_2(); delay(dl);}
if( FLAG==3){schag_11(); delay(dl);} 
if( FLAG==4){schag_22(); delay(dl);}
if( FLAG==0){stoptok();}
}
///////////////////////////////////////
void schag_1(){//шаг по часовой стрелке
 bool c=f4;f4=f3;f3=f2;f2=f1;f1=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 
}
//////////////////////////////////////
void schag_2(){//шаг против часовой стрелки
 bool c=f1;f1=f2;f2=f3;f3=f4;f4=c; 
 digitalWrite(in1, f1); digitalWrite(in2, f2); digitalWrite(in3, f3); digitalWrite(in4, f4);
 
}
//////////////////////////////////////
void stoptok(){
 digitalWrite(in1, 0); digitalWrite(in2, 0); digitalWrite(in3, 0); digitalWrite(in4, 0);
 digitalWrite(in11, 0); digitalWrite(in22, 0); digitalWrite(in33, 0); digitalWrite(in44, 0);
 }
//////////////////////////////////////
void schag_11(){//шаг по часовой стрелке
 bool cc=f44;f44=f33;f33=f22;f22=f11;f11=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);

}
//////////////////////////////////////
void schag_22(){//шаг против часовой стрелки
 bool cc=f11;f11=f22;f22=f33;f33=f44;f44=cc; 
 digitalWrite(in11, f11); digitalWrite(in22, f22); digitalWrite(in33, f33); digitalWrite(in44, f44);
 
}
/////////////////////////////////////
void vekt_(int X2,int Y2){
X2=X2*1.68;Y2=Y2*1.68;  
int Nx=abs(X1-X2)*2.608;//число шагов соответствующего мотора на заданные изменение координат
int Ny=abs(Y1-Y2)*2.608;
if(Nx==0){Nx=1;}if(Ny==0){Ny=1;}
int Kx=0;int Ky=0;//счётчики шагов
long Ym1;long Ym2; Ym1=Ym2=micros();
long DL_1=0;long DL_2=0;
if(Nx>Ny){DL_1=3000;DL_2=(DL_1*Nx)/Ny;}else{DL_2=3000;DL_1=(DL_2*Ny)/Nx;}
while(Kx<Nx&&Ky<Ny){
if(micros()-Ym1>DL_1&&Kx<Nx){Ym1=micros();Kx++;if(X1-X2>0){schag_1();}else{schag_2();}}
if(micros()-Ym2>DL_2&&Ky<Ny){Ym2=micros();Ky++;if(Y1-Y2>0){schag_11();}else{schag_22();}}  
}
X1=X2;Y1=Y2;    
}
//////////////////////////////////////
void penup(){//вверх маркер
  penServo.attach(servoPin);
  for(int i=PEN_DOWN;i>=PEN_UP;i--){
  penServo.write(i);
  delay(2*dl/1);
  }
 penServo.detach(); 
}
///////////////////
void pendown(){//вниз маркер
  penServo.attach(servoPin);
for(int i=PEN_UP;i<=PEN_DOWN;i++){
  penServo.write(i);
  delay(2*dl/1);
  } 
 penServo.detach(); 
}
///////////////////////////////////////
////РИСУНКИ
void ris_1(){//он и она
vekt_(112,325);
pendown();
vekt_(158,326);
vekt_(189,311);
vekt_(208,279);
vekt_(210,235);
vekt_(187,111);
vekt_(200,76);
vekt_(238,52);
vekt_(283,48);
vekt_(330,56);
vekt_(384,82);
vekt_(433,108);
vekt_(474,139);
vekt_(495,169);
vekt_(496,188);
vekt_(454,219);
vekt_(441,243);
vekt_(430,279);
vekt_(386,260);
vekt_(349,229);
vekt_(328,205);
vekt_(318,181);
vekt_(319,164);
vekt_(337,148);
vekt_(362,166);
vekt_(387,202);
vekt_(418,276);
vekt_(434,362);
vekt_(462,406);
vekt_(463,457);
vekt_(473,465);
vekt_(489,458);
vekt_(515,480);
vekt_(514,500);
vekt_(519,527);
vekt_(525,556);
vekt_(511,563);
vekt_(495,555);
vekt_(491,541);
vekt_(493,530);
vekt_(507,539);
vekt_(498,520);
vekt_(488,504);
vekt_(476,502);
vekt_(472,525);
vekt_(476,548);
vekt_(517,610);
vekt_(523,653);
vekt_(514,703);
vekt_(479,748);
vekt_(429,787);
vekt_(408,822);
vekt_(401,862);
vekt_(420,884);
vekt_(493,926);
vekt_(521,968);
penup();
vekt_(432,363);
pendown();
vekt_(370,315);
vekt_(335,293);
vekt_(310,283);
vekt_(290,286);
vekt_(269,297);
vekt_(266,316);
vekt_(275,333);
vekt_(294,338);
vekt_(311,349);
vekt_(285,343);
vekt_(269,345);
vekt_(257,349);
vekt_(252,358);
vekt_(244,363);
vekt_(260,389);
vekt_(274,384);
vekt_(286,390);
vekt_(303,385);
vekt_(318,378);
vekt_(348,377);
vekt_(331,364);
vekt_(312,361);
vekt_(286,365);
vekt_(249,360);
penup();
vekt_(147,539);
pendown();
vekt_(156,524);
vekt_(159,509);
vekt_(170,502);
vekt_(191,496);
vekt_(206,497);
vekt_(232,499);
vekt_(225,491);
vekt_(209,482);
vekt_(189,482);
vekt_(169,494);
vekt_(226,509);
vekt_(217,525);
vekt_(201,530);
vekt_(180,524);
vekt_(166,506);
penup();
vekt_(299,417);
pendown();
vekt_(283,411);
vekt_(262,410);
vekt_(240,418);
vekt_(244,439);
vekt_(249,470);
vekt_(247,501);
vekt_(236,524);
vekt_(216,536);
vekt_(188,539);
vekt_(167,541);
vekt_(175,548);
vekt_(214,545);
vekt_(221,554);
vekt_(214,562);
vekt_(197,560);
vekt_(169,556);
vekt_(142,550);
vekt_(145,583);
vekt_(144,625);
vekt_(156,668);
vekt_(172,712);
vekt_(197,757);
vekt_(242,785);
penup();
vekt_(287,515);
pendown();
vekt_(317,498);
vekt_(338,499);
vekt_(356,501);
vekt_(373,525);
vekt_(350,514);
vekt_(333,510);
vekt_(307,513);
vekt_(294,523);
vekt_(301,540);
vekt_(318,548);
vekt_(343,552);
vekt_(371,548);
vekt_(393,558);
vekt_(338,564);
vekt_(293,549);
vekt_(286,566);
vekt_(300,577);
vekt_(334,581);
vekt_(367,574);
vekt_(399,565);
vekt_(421,566);
vekt_(429,586);
vekt_(426,622);
vekt_(442,653);
vekt_(441,689);
vekt_(408,751);
vekt_(398,738);
vekt_(386,703);
vekt_(347,665);
vekt_(290,636);
vekt_(230,630);
vekt_(199,625);
vekt_(165,606);
vekt_(147,564);
penup();
vekt_(871,74);
pendown();
vekt_(867,147);
vekt_(833,238);
vekt_(785,275);
vekt_(722,320);
vekt_(668,361);
vekt_(621,400);
vekt_(617,437);
vekt_(633,496);
penup();
vekt_(511,368);
pendown();
vekt_(533,460);
vekt_(550,492);
vekt_(582,505);
vekt_(596,516);
vekt_(603,535);
vekt_(619,530);
vekt_(650,505);
vekt_(688,484);
vekt_(720,461);
vekt_(747,462);
vekt_(773,473);
vekt_(785,490);
vekt_(786,514);
vekt_(795,533);
vekt_(807,537);
vekt_(809,550);
vekt_(800,561);
vekt_(771,580);
vekt_(790,585);
vekt_(807,585);
vekt_(820,585);
vekt_(829,584);
vekt_(829,574);
vekt_(816,568);
penup();
vekt_(834,609);
pendown();
vekt_(826,601);
vekt_(833,587);
penup();
vekt_(815,653);
pendown();
vekt_(802,645);
vekt_(804,630);
vekt_(823,631);
vekt_(849,633);
vekt_(851,625);
vekt_(840,619);
vekt_(853,615);
vekt_(868,621);
vekt_(884,631);
vekt_(881,644);
vekt_(858,729);
vekt_(875,743);
vekt_(882,762);
vekt_(878,782);
vekt_(879,818);
vekt_(884,862);
vekt_(872,915);
penup();
vekt_(818,940);
pendown();
vekt_(800,904);
vekt_(769,868);
vekt_(741,851);
vekt_(698,839);
vekt_(650,807);
vekt_(641,786);
vekt_(654,761);
vekt_(662,709);
vekt_(692,660);
vekt_(696,636);
vekt_(692,597);
vekt_(696,557);
vekt_(709,542);
vekt_(713,553);
vekt_(724,581);
vekt_(768,678);
vekt_(770,717);
vekt_(738,733);
vekt_(683,750);
vekt_(645,749);
vekt_(626,734);
vekt_(612,699);
penup();
vekt_(714,489);
pendown();
vekt_(688,499);
vekt_(662,529);
vekt_(613,580);
vekt_(576,619);
vekt_(565,661);
vekt_(576,702);
vekt_(590,743);
vekt_(578,741);
vekt_(562,754);
vekt_(542,779);
vekt_(524,800);
vekt_(524,830);
vekt_(535,868);
vekt_(549,889);
vekt_(579,906);
vekt_(600,901);
vekt_(619,887);
vekt_(625,870);
vekt_(622,853);
vekt_(602,839);
vekt_(597,848);
vekt_(602,863);
vekt_(602,884);
vekt_(586,889);
vekt_(568,879);
vekt_(561,866);
vekt_(569,852);
vekt_(581,849);
vekt_(578,840);
vekt_(568,829);
vekt_(555,815);
vekt_(557,801);
vekt_(567,786);
vekt_(582,782);
vekt_(595,792);
vekt_(595,805);
vekt_(580,805);
vekt_(577,799);
penup();
vekt_(791,749);
pendown();
vekt_(818,735);
vekt_(830,737);
vekt_(834,749);
vekt_(817,758);
vekt_(797,763);
vekt_(779,773);
vekt_(802,774);
vekt_(822,769);
vekt_(834,763);
vekt_(842,752);
vekt_(852,748);
vekt_(864,750);
vekt_(868,762);
vekt_(851,778);
vekt_(812,802);
vekt_(782,801);
vekt_(745,805);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 292
}
///////////////////////////////////////
void ris_2(){//лев
vekt_(331,116);
pendown();
vekt_(331,233);
vekt_(316,232);
vekt_(294,210);
vekt_(266,201);
vekt_(238,211);
vekt_(214,254);
vekt_(281,255);
vekt_(293,297);
vekt_(266,289);
vekt_(216,279);
vekt_(171,289);
vekt_(140,321);
vekt_(133,357);
vekt_(145,413);
vekt_(53,393);
vekt_(95,338);
vekt_(183,235);
vekt_(334,116);
penup();
vekt_(249,546);
pendown();
vekt_(247,621);
vekt_(335,620);
vekt_(250,545);
penup();
vekt_(190,541);
pendown();
vekt_(159,514);
vekt_(161,633);
vekt_(255,716);
vekt_(211,740);
vekt_(163,736);
vekt_(127,724);
vekt_(126,746);
vekt_(163,771);
vekt_(203,784);
vekt_(252,787);
vekt_(298,786);
vekt_(299,840);
vekt_(319,878);
vekt_(344,901);
vekt_(390,924);
vekt_(403,727);
vekt_(350,733);
vekt_(297,711);
vekt_(185,619);
vekt_(189,539);
penup();
vekt_(340,283);
pendown();
vekt_(338,391);
vekt_(405,399);
vekt_(481,426);
vekt_(526,483);
vekt_(530,553);
vekt_(517,596);
vekt_(486,651);
vekt_(532,619);
vekt_(554,576);
vekt_(560,516);
vekt_(555,436);
vekt_(533,369);
vekt_(455,377);
vekt_(419,361);
vekt_(339,282);
penup();
vekt_(785,47);
pendown();
vekt_(694,38);
vekt_(609,45);
vekt_(538,66);
vekt_(498,116);
vekt_(492,194);
vekt_(512,275);
vekt_(617,519);
vekt_(621,558);
vekt_(604,593);
vekt_(578,634);
vekt_(539,663);
vekt_(494,681);
vekt_(601,673);
vekt_(700,655);
vekt_(768,627);
vekt_(829,576);
vekt_(860,510);
vekt_(858,462);
vekt_(838,409);
vekt_(777,313);
vekt_(740,259);
vekt_(728,210);
vekt_(776,148);
vekt_(730,164);
vekt_(700,190);
vekt_(692,244);
vekt_(697,309);
vekt_(702,380);
vekt_(708,446);
vekt_(712,535);
vekt_(696,578);
vekt_(671,609);
vekt_(621,637);
vekt_(668,588);
vekt_(687,545);
vekt_(683,470);
vekt_(651,251);
vekt_(655,151);
vekt_(677,96);
vekt_(719,68);
vekt_(785,44);
penup();
vekt_(906,494);
pendown();
vekt_(867,580);
vekt_(825,645);
vekt_(779,688);
vekt_(725,709);
vekt_(668,719);
vekt_(505,726);
vekt_(558,771);
vekt_(635,806);
vekt_(698,813);
vekt_(764,809);
vekt_(823,788);
vekt_(881,747);
vekt_(917,696);
vekt_(938,648);
vekt_(942,593);
vekt_(904,492);
penup();
vekt_(776,857);
pendown();
vekt_(769,890);
vekt_(746,913);
vekt_(712,926);
vekt_(670,924);
vekt_(625,913);
vekt_(571,889);
vekt_(526,850);
vekt_(497,811);
vekt_(472,733);
vekt_(522,787);
vekt_(591,825);
vekt_(653,842);
vekt_(781,858);
penup();
vekt_(599,943);
pendown();
vekt_(562,957);
vekt_(515,962);
vekt_(470,945);
vekt_(440,907);
vekt_(430,852);
vekt_(436,736);
vekt_(471,829);
vekt_(519,888);
vekt_(601,946);
penup();
vekt_(0,0);
//X1=0;Y1=0;
}
//////////////////////////////
void ris_3(){//индеец
vekt_(303,90);
pendown();
vekt_(308,139);
vekt_(294,189);
vekt_(264,228);
vekt_(212,254);
vekt_(164,266);
vekt_(91,263);
vekt_(66,256);
vekt_(67,236);
vekt_(88,221);
vekt_(133,218);
vekt_(175,213);
vekt_(205,202);
vekt_(224,176);
vekt_(192,168);
vekt_(145,175);
vekt_(95,177);
vekt_(94,143);
vekt_(120,126);
vekt_(149,126);
vekt_(177,100);
vekt_(219,82);
vekt_(257,80);
vekt_(308,91);
penup();
vekt_(456,95);
pendown();
vekt_(434,215);
vekt_(431,330);
vekt_(445,388);
vekt_(470,467);
vekt_(425,485);
vekt_(383,477);
vekt_(342,448);
vekt_(293,423);
vekt_(232,420);
vekt_(190,441);
vekt_(168,485);
vekt_(169,542);
vekt_(193,575);
vekt_(232,589);
vekt_(287,585);
vekt_(326,567);
vekt_(370,536);
vekt_(417,519);
vekt_(462,532);
vekt_(480,558);
vekt_(478,580);
vekt_(411,600);
vekt_(331,630);
vekt_(247,647);
vekt_(157,649);
vekt_(132,589);
vekt_(119,524);
vekt_(97,476);
vekt_(63,446);
vekt_(50,385);
vekt_(44,298);
vekt_(79,290);
vekt_(116,290);
vekt_(144,311);
vekt_(153,342);
vekt_(110,362);
vekt_(134,374);
vekt_(173,371);
vekt_(183,335);
vekt_(204,300);
vekt_(239,277);
vekt_(289,248);
vekt_(319,216);
vekt_(337,168);
vekt_(344,85);
vekt_(397,79);
vekt_(458,96);
penup();
vekt_(554,59);
pendown();
vekt_(597,93);
vekt_(621,124);
vekt_(634,167);
vekt_(576,184);
vekt_(512,188);
vekt_(478,185);
vekt_(485,137);
vekt_(509,100);
vekt_(555,56);
penup();
vekt_(543,112);
pendown();
vekt_(560,112);
vekt_(574,126);
vekt_(579,145);
vekt_(522,150);
vekt_(542,111);
penup();
vekt_(631,210);
pendown();
vekt_(650,258);
vekt_(657,316);
vekt_(649,370);
vekt_(628,382);
vekt_(569,388);
vekt_(513,388);
vekt_(481,375);
vekt_(465,343);
vekt_(463,293);
vekt_(474,236);
vekt_(492,216);
vekt_(556,209);
vekt_(636,212);
penup();
vekt_(572,275);
pendown();
vekt_(588,297);
vekt_(587,319);
vekt_(567,329);
vekt_(541,326);
vekt_(527,301);
vekt_(534,278);
vekt_(553,266);
vekt_(576,281);
penup();
vekt_(604,411);
pendown();
vekt_(636,466);
vekt_(651,506);
vekt_(644,549);
vekt_(619,574);
vekt_(583,581);
vekt_(535,573);
vekt_(511,551);
vekt_(508,518);
vekt_(521,490);
vekt_(559,490);
vekt_(560,512);
vekt_(560,537);
vekt_(586,540);
vekt_(602,520);
vekt_(593,489);
vekt_(568,467);
vekt_(537,448);
vekt_(524,419);
vekt_(560,408);
vekt_(608,414);
penup();
vekt_(243,552);
pendown();
vekt_(204,561);
vekt_(195,528);
vekt_(197,488);
vekt_(216,452);
vekt_(249,440);
vekt_(289,446);
vekt_(319,464);
vekt_(343,497);
vekt_(343,530);
vekt_(322,552);
vekt_(293,552);
vekt_(259,544);
vekt_(253,519);
vekt_(268,501);
vekt_(293,489);
vekt_(269,472);
vekt_(241,486);
vekt_(232,508);
vekt_(241,555);
penup();
vekt_(657,607);
pendown();
vekt_(656,642);
vekt_(640,656);
vekt_(562,659);
vekt_(496,669);
vekt_(420,707);
vekt_(355,733);
vekt_(285,757);
vekt_(203,772);
vekt_(141,776);
vekt_(94,766);
vekt_(94,746);
vekt_(104,712);
vekt_(124,677);
vekt_(157,673);
vekt_(201,679);
vekt_(270,673);
vekt_(340,654);
vekt_(416,627);
vekt_(494,609);
vekt_(570,603);
vekt_(662,606);
penup();
vekt_(112,848);
pendown();
vekt_(127,850);
vekt_(229,969);
vekt_(143,972);
vekt_(113,909);
vekt_(109,848);
penup();
vekt_(128,799);
pendown();
vekt_(219,804);
vekt_(346,908);
vekt_(362,935);
vekt_(292,968);
vekt_(270,964);
vekt_(208,909);
vekt_(154,846);
vekt_(129,798);
penup();
vekt_(274,802);
pendown();
vekt_(409,904);
vekt_(446,910);
vekt_(473,902);
vekt_(501,887);
vekt_(437,820);
vekt_(394,791);
vekt_(353,775);
vekt_(273,806);
penup();
vekt_(406,754);
pendown();
vekt_(481,818);
vekt_(544,869);
vekt_(573,871);
vekt_(614,860);
vekt_(519,710);
vekt_(493,701);
vekt_(451,714);
vekt_(406,754);
penup();
vekt_(563,703);
pendown();
vekt_(618,805);
vekt_(638,851);
vekt_(675,876);
vekt_(721,883);
vekt_(765,873);
vekt_(800,842);
vekt_(828,799);
vekt_(863,791);
vekt_(862,848);
vekt_(882,860);
vekt_(906,849);
vekt_(924,821);
vekt_(924,784);
vekt_(905,754);
vekt_(847,741);
vekt_(795,767);
vekt_(764,813);
vekt_(722,833);
vekt_(676,822);
vekt_(658,787);
vekt_(646,736);
vekt_(629,691);
vekt_(596,680);
vekt_(563,703);
penup();
vekt_(687,636);
pendown();
vekt_(678,665);
vekt_(684,704);
vekt_(684,732);
vekt_(675,769);
vekt_(687,793);
vekt_(713,806);
vekt_(745,799);
vekt_(759,764);
vekt_(775,735);
vekt_(815,694);
vekt_(813,664);
vekt_(798,639);
vekt_(767,621);
vekt_(719,618);
vekt_(685,636);
penup();
vekt_(899,649);
pendown();
vekt_(924,658);
vekt_(933,688);
vekt_(926,717);
vekt_(907,730);
vekt_(880,725);
vekt_(859,705);
vekt_(857,681);
vekt_(865,657);
vekt_(901,650);
penup();
vekt_(841,626);
pendown();
vekt_(900,550);
vekt_(931,498);
vekt_(949,440);
vekt_(944,396);
vekt_(917,373);
vekt_(890,383);
vekt_(859,457);
vekt_(834,536);
vekt_(808,605);
vekt_(842,627);
penup();
vekt_(790,594);
pendown();
vekt_(827,466);
vekt_(871,328);
vekt_(897,226);
vekt_(900,142);
vekt_(879,109);
vekt_(841,114);
vekt_(815,172);
vekt_(746,590);
vekt_(792,595);
penup();
vekt_(713,590);
pendown();
vekt_(725,545);
vekt_(735,459);
vekt_(755,319);
vekt_(762,197);
vekt_(750,106);
vekt_(735,87);
vekt_(707,71);
vekt_(686,93);
vekt_(677,154);
vekt_(684,241);
vekt_(691,331);
vekt_(690,430);
vekt_(679,513);
vekt_(682,590);
vekt_(716,590);
penup();
vekt_(0,0);
//X1=0;Y1=0;
}
///////////////////////////////
void ris_4(){//волк
vekt_(474,391);
pendown();
vekt_(398,404);
vekt_(316,413);
vekt_(252,413);
vekt_(205,407);
vekt_(192,416);
vekt_(185,446);
vekt_(149,439);
vekt_(101,479);
vekt_(109,534);
vekt_(40,632);
vekt_(57,671);
vekt_(148,662);
vekt_(293,700);
vekt_(290,739);
vekt_(299,751);
vekt_(448,793);
vekt_(474,837);
vekt_(448,851);
vekt_(426,800);
vekt_(416,803);
vekt_(427,860);
vekt_(419,920);
vekt_(488,889);
vekt_(493,948);
vekt_(536,938);
vekt_(628,837);
vekt_(725,809);
vekt_(806,765);
vekt_(864,714);
vekt_(918,644);
vekt_(957,570);
vekt_(890,636);
vekt_(822,690);
vekt_(720,727);
vekt_(755,653);
vekt_(786,560);
vekt_(732,576);
vekt_(680,581);
vekt_(703,513);
vekt_(716,428);
vekt_(707,316);
vekt_(654,367);
vekt_(598,401);
vekt_(616,342);
vekt_(626,244);
vekt_(611,154);
vekt_(585,103);
vekt_(587,179);
vekt_(577,272);
vekt_(542,359);
vekt_(482,425);
vekt_(450,451);
vekt_(526,474);
vekt_(615,468);
vekt_(652,464);
vekt_(631,538);
vekt_(588,606);
vekt_(560,639);
vekt_(613,641);
vekt_(679,625);
vekt_(725,610);
vekt_(688,673);
vekt_(628,725);
vekt_(544,758);
vekt_(579,788);
vekt_(530,849);
vekt_(498,794);
vekt_(464,758);
vekt_(450,776);
vekt_(333,737);
vekt_(315,665);
vekt_(128,619);
vekt_(106,583);
vekt_(152,537);
vekt_(143,495);
vekt_(154,485);
vekt_(301,506);
vekt_(319,547);
vekt_(350,525);
vekt_(368,479);
vekt_(356,477);
vekt_(325,504);
vekt_(303,478);
vekt_(254,465);
vekt_(258,455);
vekt_(329,449);
vekt_(413,429);
vekt_(475,386);
penup();
vekt_(262,595);
pendown();
vekt_(347,629);
vekt_(443,655);
vekt_(442,674);
vekt_(504,737);
vekt_(422,727);
vekt_(343,708);
vekt_(349,675);
vekt_(307,644);
vekt_(261,595);
penup();
vekt_(365,660);
pendown();
vekt_(371,690);
vekt_(434,701);
vekt_(437,691);
vekt_(365,661);
penup();
vekt_(835,647);
pendown();
vekt_(909,570);
vekt_(939,485);
vekt_(947,398);
vekt_(932,318);
vekt_(914,258);
vekt_(867,195);
vekt_(865,280);
vekt_(836,363);
vekt_(780,488);
vekt_(833,447);
vekt_(885,375);
vekt_(889,461);
vekt_(874,537);
vekt_(836,648);
penup();
vekt_(809,343);
pendown();
vekt_(832,262);
vekt_(836,177);
vekt_(771,121);
vekt_(684,74);
vekt_(602,44);
vekt_(513,28);
vekt_(602,78);
vekt_(684,155);
vekt_(744,231);
vekt_(811,345);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 131
//X1=0;Y1=0;
}
///////////////////////////////////////
void ris_5(){// луна-солнце
vekt_(450,211);
pendown();
vekt_(390,231);
vekt_(338,255);
vekt_(276,305);
vekt_(239,354);
vekt_(207,434);
vekt_(201,504);
vekt_(205,570);
vekt_(229,633);
vekt_(265,687);
vekt_(318,739);
vekt_(388,772);
vekt_(457,792);
vekt_(525,791);
vekt_(584,775);
vekt_(653,748);
vekt_(642,805);
vekt_(624,794);
vekt_(595,774);
vekt_(600,816);
vekt_(584,865);
vekt_(567,904);
vekt_(525,941);
vekt_(507,909);
vekt_(498,866);
vekt_(485,824);
vekt_(466,792);
vekt_(458,820);
vekt_(428,855);
vekt_(396,883);
vekt_(369,914);
vekt_(367,952);
vekt_(340,933);
vekt_(325,892);
vekt_(329,858);
vekt_(342,808);
vekt_(336,754);
vekt_(305,782);
vekt_(263,798);
vekt_(216,810);
vekt_(191,825);
vekt_(182,856);
vekt_(166,832);
vekt_(166,794);
vekt_(182,759);
vekt_(206,732);
vekt_(231,698);
vekt_(242,665);
vekt_(197,673);
vekt_(151,668);
vekt_(109,660);
vekt_(76,668);
vekt_(53,685);
vekt_(57,648);
vekt_(72,619);
vekt_(100,598);
vekt_(131,584);
vekt_(163,565);
vekt_(197,538);
vekt_(160,529);
vekt_(126,510);
vekt_(99,487);
vekt_(74,472);
vekt_(48,465);
vekt_(21,471);
vekt_(35,438);
vekt_(56,424);
vekt_(91,413);
vekt_(127,415);
vekt_(163,416);
vekt_(192,415);
vekt_(217,402);
vekt_(190,388);
vekt_(167,359);
vekt_(149,323);
vekt_(131,292);
vekt_(117,279);
vekt_(84,268);
vekt_(107,251);
vekt_(137,241);
vekt_(162,247);
vekt_(199,266);
vekt_(232,281);
vekt_(256,292);
vekt_(285,292);
vekt_(270,264);
vekt_(262,227);
vekt_(263,178);
vekt_(290,168);
vekt_(337,170);
vekt_(358,193);
vekt_(371,210);
vekt_(399,224);
vekt_(398,192);
vekt_(415,194);
vekt_(449,213);
penup();
vekt_(516,245);
pendown();
vekt_(470,246);
vekt_(420,253);
vekt_(363,277);
vekt_(314,311);
vekt_(278,349);
vekt_(250,399);
vekt_(231,464);
vekt_(232,532);
vekt_(245,594);
vekt_(280,657);
vekt_(325,702);
vekt_(388,741);
vekt_(461,760);
vekt_(519,759);
vekt_(575,746);
vekt_(628,720);
vekt_(661,689);
vekt_(658,652);
vekt_(646,611);
vekt_(629,568);
vekt_(592,520);
vekt_(549,485);
vekt_(494,460);
vekt_(452,444);
vekt_(432,425);
vekt_(429,391);
vekt_(447,363);
vekt_(478,331);
vekt_(497,309);
vekt_(495,280);
vekt_(517,244);
penup();
vekt_(259,498);
pendown();
vekt_(296,487);
vekt_(329,484);
vekt_(369,483);
vekt_(391,475);
vekt_(409,461);
vekt_(418,446);
vekt_(391,435);
vekt_(359,434);
vekt_(323,439);
vekt_(292,454);
vekt_(270,478);
vekt_(260,501);
penup();
vekt_(821,498);
pendown();
vekt_(804,469);
vekt_(779,447);
vekt_(744,437);
vekt_(715,434);
vekt_(685,436);
vekt_(660,446);
vekt_(673,466);
vekt_(698,479);
vekt_(731,484);
vekt_(764,481);
vekt_(789,486);
vekt_(825,502);
penup();
vekt_(170,169);
pendown();
vekt_(238,158);
vekt_(305,152);
vekt_(367,159);
vekt_(414,176);
vekt_(449,200);
vekt_(481,214);
vekt_(518,214);
vekt_(557,208);
vekt_(598,209);
vekt_(635,217);
vekt_(680,246);
vekt_(637,244);
vekt_(597,245);
vekt_(558,256);
vekt_(515,270);
vekt_(520,302);
vekt_(511,326);
vekt_(490,351);
vekt_(464,377);
vekt_(448,398);
vekt_(449,415);
vekt_(476,431);
vekt_(522,450);
vekt_(569,477);
vekt_(612,511);
vekt_(647,565);
vekt_(668,621);
vekt_(681,668);
vekt_(681,732);
vekt_(662,798);
vekt_(631,851);
vekt_(602,892);
vekt_(536,961);
vekt_(601,950);
vekt_(677,923);
vekt_(760,877);
vekt_(832,804);
vekt_(891,727);
vekt_(933,635);
vekt_(952,530);
vekt_(941,417);
vekt_(912,322);
vekt_(866,236);
vekt_(804,162);
vekt_(711,97);
vekt_(595,52);
vekt_(489,40);
vekt_(390,50);
vekt_(298,79);
vekt_(230,117);
vekt_(171,173);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 207
//X1=0;Y1=0;
}
///////////////////////////
void ris_6(){// орёл
vekt_(40,368);
pendown();
vekt_(70,367);
vekt_(114,383);
vekt_(167,414);
vekt_(187,441);
vekt_(203,469);
vekt_(227,501);
vekt_(242,519);
vekt_(262,527);
vekt_(271,523);
vekt_(268,498);
vekt_(228,409);
vekt_(228,373);
vekt_(243,341);
vekt_(274,303);
vekt_(295,381);
vekt_(317,425);
vekt_(349,462);
vekt_(367,469);
vekt_(367,448);
vekt_(358,388);
vekt_(352,330);
vekt_(353,285);
vekt_(371,236);
vekt_(392,215);
vekt_(407,213);
vekt_(414,230);
vekt_(412,274);
vekt_(422,316);
vekt_(439,343);
vekt_(452,360);
vekt_(467,362);
vekt_(466,350);
vekt_(450,308);
vekt_(444,271);
vekt_(451,232);
vekt_(471,192);
vekt_(499,168);
vekt_(522,161);
vekt_(530,168);
vekt_(532,188);
vekt_(536,224);
vekt_(547,264);
vekt_(562,285);
vekt_(571,291);
vekt_(574,277);
vekt_(574,235);
vekt_(579,194);
vekt_(589,161);
vekt_(605,151);
vekt_(614,164);
vekt_(629,192);
vekt_(646,220);
vekt_(660,224);
vekt_(669,205);
vekt_(682,170);
vekt_(693,137);
vekt_(696,123);
vekt_(709,128);
vekt_(719,153);
vekt_(720,183);
vekt_(711,239);
vekt_(696,307);
vekt_(687,388);
vekt_(691,447);
vekt_(705,500);
vekt_(724,531);
vekt_(779,562);
vekt_(707,561);
vekt_(685,541);
vekt_(664,513);
vekt_(650,485);
vekt_(629,471);
vekt_(601,473);
vekt_(591,486);
vekt_(607,513);
vekt_(619,530);
vekt_(622,548);
vekt_(611,569);
vekt_(595,556);
vekt_(576,532);
vekt_(546,514);
vekt_(510,510);
vekt_(484,527);
vekt_(471,557);
vekt_(498,595);
vekt_(537,626);
vekt_(573,642);
vekt_(627,651);
vekt_(669,663);
vekt_(695,679);
vekt_(719,714);
vekt_(662,685);
vekt_(618,690);
vekt_(529,726);
vekt_(490,742);
vekt_(446,737);
vekt_(400,717);
vekt_(363,698);
vekt_(334,692);
vekt_(345,716);
vekt_(394,756);
vekt_(441,780);
vekt_(490,791);
vekt_(547,790);
vekt_(605,785);
vekt_(725,769);
vekt_(685,794);
vekt_(640,800);
vekt_(587,809);
vekt_(526,810);
vekt_(495,817);
vekt_(486,827);
vekt_(499,837);
vekt_(532,843);
vekt_(570,844);
vekt_(661,841);
vekt_(763,838);
vekt_(729,857);
vekt_(680,871);
vekt_(620,881);
vekt_(556,881);
vekt_(491,875);
vekt_(440,856);
vekt_(408,836);
vekt_(369,807);
vekt_(341,779);
vekt_(299,737);
vekt_(261,679);
vekt_(237,640);
vekt_(201,580);
vekt_(183,537);
vekt_(147,491);
vekt_(116,454);
vekt_(81,420);
vekt_(42,367);
penup();
vekt_(554,771);
pendown();
vekt_(649,750);
vekt_(632,731);
vekt_(611,721);
vekt_(585,721);
vekt_(570,731);
vekt_(558,747);
vekt_(554,773);
penup();
vekt_(668,626);
pendown();
vekt_(714,636);
vekt_(754,653);
vekt_(783,676);
vekt_(792,717);
vekt_(801,752);
vekt_(824,789);
vekt_(852,775);
vekt_(889,748);
vekt_(916,718);
vekt_(941,673);
vekt_(955,630);
vekt_(961,585);
vekt_(955,534);
vekt_(928,578);
vekt_(900,613);
vekt_(869,637);
vekt_(833,641);
vekt_(799,625);
vekt_(772,612);
vekt_(742,605);
vekt_(698,610);
vekt_(668,629);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 168

}
////////////////////////////////
void ris_7(){// дерево
vekt_(339,49);
pendown();
vekt_(342,118);
vekt_(353,188);
vekt_(373,265);
vekt_(399,327);
vekt_(426,378);
vekt_(413,422);
vekt_(375,485);
vekt_(314,541);
vekt_(369,525);
vekt_(407,501);
vekt_(434,471);
vekt_(459,429);
vekt_(498,470);
vekt_(545,508);
vekt_(589,531);
vekt_(649,546);
vekt_(598,488);
vekt_(560,439);
vekt_(514,365);
vekt_(482,283);
vekt_(465,201);
vekt_(456,128);
vekt_(451,48);
vekt_(339,46);
penup();
vekt_(801,318);delay(5000);// пауза для смены фломастера (цвет)
pendown();
vekt_(742,308);
vekt_(677,308);
vekt_(624,322);
vekt_(591,346);
vekt_(577,387);
vekt_(622,388);
vekt_(665,382);
vekt_(721,365);
vekt_(678,395);
vekt_(627,410);
vekt_(589,420);
vekt_(627,450);
vekt_(679,456);
vekt_(725,431);
vekt_(757,399);
vekt_(780,363);
vekt_(802,316);
penup();
vekt_(851,641);
pendown();
vekt_(806,613);
vekt_(764,580);
vekt_(723,532);
vekt_(756,514);
vekt_(804,519);
vekt_(853,545);
vekt_(892,592);
vekt_(946,672);
vekt_(892,689);
vekt_(827,694);
vekt_(770,683);
vekt_(728,660);
vekt_(707,620);
vekt_(701,569);
vekt_(755,604);
vekt_(810,629);
vekt_(853,639);
penup();
vekt_(815,860);
pendown();
vekt_(791,828);
vekt_(773,795);
vekt_(758,752);
vekt_(798,755);
vekt_(836,787);
vekt_(861,839);
vekt_(877,915);
vekt_(817,905);
vekt_(773,889);
vekt_(734,858);
vekt_(722,824);
vekt_(731,770);
vekt_(760,809);
vekt_(784,839);
vekt_(816,862);
penup();
vekt_(619,835);
pendown();
vekt_(613,800);
vekt_(608,768);
vekt_(605,712);
vekt_(614,670);
vekt_(660,694);
vekt_(684,754);
vekt_(687,823);
vekt_(675,880);
vekt_(664,933);
vekt_(598,886);
vekt_(546,836);
vekt_(526,778);
vekt_(532,729);
vekt_(570,679);
vekt_(579,734);
vekt_(591,782);
vekt_(620,838);
penup();
vekt_(444,884);
pendown();
vekt_(461,849);
vekt_(472,797);
vekt_(490,811);
vekt_(499,839);
vekt_(491,879);
vekt_(456,918);
vekt_(412,946);
vekt_(403,895);
vekt_(401,842);
vekt_(420,807);
vekt_(452,790);
vekt_(451,817);
vekt_(448,850);
vekt_(445,884);
penup();
vekt_(441,663);
pendown();
vekt_(457,638);
vekt_(472,605);
vekt_(476,577);
vekt_(497,599);
vekt_(500,628);
vekt_(484,668);
vekt_(454,691);
vekt_(405,720);
vekt_(400,681);
vekt_(402,633);
vekt_(416,590);
vekt_(442,571);
vekt_(457,570);
vekt_(455,606);
vekt_(445,641);
vekt_(443,665);
penup();
vekt_(243,856);
pendown();
vekt_(285,832);
vekt_(336,781);
vekt_(347,820);
vekt_(334,854);
vekt_(297,885);
vekt_(251,897);
vekt_(178,898);
vekt_(188,856);
vekt_(213,806);
vekt_(245,765);
vekt_(288,751);
vekt_(316,757);
vekt_(298,793);
vekt_(274,825);
vekt_(242,856);
penup();
vekt_(153,650);
pendown();
vekt_(210,632);
vekt_(247,612);
vekt_(301,575);
vekt_(297,633);
vekt_(264,673);
vekt_(211,701);
vekt_(135,702);
vekt_(55,684);
vekt_(85,634);
vekt_(127,580);
vekt_(165,549);
vekt_(222,526);
vekt_(278,540);
vekt_(239,587);
vekt_(193,623);
vekt_(152,653);
penup();
vekt_(233,395);
pendown();
vekt_(272,418);
vekt_(334,437);
vekt_(303,460);
vekt_(246,456);
vekt_(211,426);
vekt_(186,391);
vekt_(166,356);
vekt_(218,347);
vekt_(282,352);
vekt_(318,370);
vekt_(342,399);
vekt_(344,409);
vekt_(303,409);
vekt_(260,402);
vekt_(230,395);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 177
}
///////////////////////////////
void ris_8(){// микки маус
vekt_(502,385);
pendown();
vekt_(479,425);
vekt_(459,470);
vekt_(447,532);
vekt_(450,586);
vekt_(470,636);
vekt_(509,667);
vekt_(562,676);
vekt_(608,665);
vekt_(651,643);
vekt_(686,609);
vekt_(688,644);
vekt_(702,647);
vekt_(730,630);
vekt_(764,595);
vekt_(796,541);
vekt_(815,500);
vekt_(828,452);
vekt_(829,422);
vekt_(813,420);
vekt_(809,461);
vekt_(798,499);
vekt_(784,533);
vekt_(766,552);
vekt_(748,550);
vekt_(741,531);
vekt_(745,503);
vekt_(751,472);
vekt_(775,405);
vekt_(760,390);
vekt_(780,396);
vekt_(805,403);
vekt_(834,408);
vekt_(856,405);
vekt_(851,389);
vekt_(850,360);
vekt_(863,343);
vekt_(882,337);
vekt_(901,337);
vekt_(892,297);
vekt_(871,262);
vekt_(829,227);
vekt_(758,207);
vekt_(686,210);
vekt_(621,224);
vekt_(556,251);
vekt_(494,287);
vekt_(445,344);
vekt_(440,333);
vekt_(450,321);
vekt_(472,293);
vekt_(491,242);
vekt_(518,192);
vekt_(547,160);
vekt_(588,140);
vekt_(630,143);
vekt_(660,156);
vekt_(692,186);
vekt_(726,187);
vekt_(702,162);
vekt_(678,140);
vekt_(637,119);
vekt_(590,112);
vekt_(541,124);
vekt_(511,149);
vekt_(472,207);
vekt_(466,205);
vekt_(471,173);
vekt_(427,194);
vekt_(380,233);
vekt_(352,280);
vekt_(337,336);
vekt_(351,382);
vekt_(380,406);
vekt_(423,418);
vekt_(466,411);
vekt_(503,384);
penup();
vekt_(461,367);
pendown();
vekt_(438,376);
vekt_(424,372);
vekt_(415,361);
vekt_(408,347);
vekt_(410,334);
vekt_(416,318);
vekt_(423,338);
vekt_(433,357);
vekt_(462,366);
penup();
vekt_(692,366);
pendown();
vekt_(669,394);
vekt_(656,430);
vekt_(645,469);
vekt_(643,504);
vekt_(648,529);
vekt_(671,544);
vekt_(688,535);
vekt_(709,504);
vekt_(722,469);
vekt_(731,428);
vekt_(732,393);
vekt_(723,373);
vekt_(709,358);
vekt_(690,364);
penup();
vekt_(885,381);
pendown();
vekt_(876,386);
vekt_(882,401);
vekt_(889,420);
vekt_(901,436);
vekt_(913,446);
vekt_(918,441);
vekt_(915,428);
vekt_(904,409);
vekt_(884,380);
penup();
vekt_(744,187);
pendown();
vekt_(721,159);
vekt_(699,135);
vekt_(662,111);
vekt_(607,94);
vekt_(544,105);
vekt_(497,137);
vekt_(484,154);
vekt_(434,168);
vekt_(387,202);
vekt_(348,245);
vekt_(320,296);
vekt_(309,320);
vekt_(271,270);
vekt_(221,244);
vekt_(149,234);
vekt_(85,260);
vekt_(40,313);
vekt_(27,381);
vekt_(41,449);
vekt_(85,508);
vekt_(146,536);
vekt_(208,535);
vekt_(252,518);
vekt_(302,470);
vekt_(319,526);
vekt_(342,567);
vekt_(373,608);
vekt_(331,610);
vekt_(273,639);
vekt_(227,700);
vekt_(220,779);
vekt_(253,849);
vekt_(314,898);
vekt_(374,907);
vekt_(446,897);
vekt_(498,853);
vekt_(524,802);
vekt_(525,759);
vekt_(514,717);
vekt_(495,683);
vekt_(558,692);
vekt_(637,687);
vekt_(693,670);
vekt_(737,641);
vekt_(780,597);
vekt_(809,552);
vekt_(831,498);
vekt_(841,462);
vekt_(843,426);
vekt_(865,420);
vekt_(890,456);
vekt_(924,478);
vekt_(955,468);
vekt_(968,439);
vekt_(965,408);
vekt_(939,368);
vekt_(922,349);
vekt_(921,313);
vekt_(905,274);
vekt_(876,237);
vekt_(832,205);
vekt_(781,193);
vekt_(743,188);
penup();
vekt_(613,188);delay(5000);// пауза для смены фломастера (цвет)
pendown();
vekt_(614,205);
vekt_(637,203);
vekt_(659,193);
vekt_(664,181);
vekt_(640,163);
vekt_(605,156);
vekt_(571,161);
vekt_(543,182);
vekt_(530,201);
vekt_(554,216);
vekt_(581,213);
vekt_(598,203);
vekt_(617,187);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 191
}
///////////////////////////////
void ris_9(){//руки 
vekt_(6,549);
pendown();
vekt_(56,592);
vekt_(84,561);
vekt_(111,522);
vekt_(149,496);
vekt_(199,481);
vekt_(249,489);
vekt_(291,523);
vekt_(314,572);
vekt_(324,631);
vekt_(332,679);
vekt_(352,718);
vekt_(377,760);
vekt_(392,809);
vekt_(386,841);
vekt_(364,858);
vekt_(338,857);
vekt_(327,834);
vekt_(304,793);
vekt_(275,747);
vekt_(245,714);
vekt_(204,679);
vekt_(157,654);
vekt_(138,656);
vekt_(138,671);
vekt_(174,719);
vekt_(211,767);
vekt_(232,791);
vekt_(286,802);
vekt_(354,810);
vekt_(439,819);
vekt_(462,817);
vekt_(690,767);
vekt_(698,752);
vekt_(687,729);
vekt_(667,716);
vekt_(634,710);
vekt_(578,716);
vekt_(514,729);
vekt_(324,533);
vekt_(376,530);
vekt_(375,405);
vekt_(503,409);
vekt_(502,483);
vekt_(413,489);
vekt_(415,526);
vekt_(716,529);
vekt_(625,622);
vekt_(626,679);
vekt_(663,681);
vekt_(663,340);
vekt_(388,338);
vekt_(336,362);
vekt_(283,371);
vekt_(250,361);
vekt_(241,338);
vekt_(255,323);
vekt_(443,216);
vekt_(666,177);
vekt_(805,268);
vekt_(810,283);
vekt_(784,288);
vekt_(724,276);
vekt_(634,218);
vekt_(582,173);
vekt_(559,142);
vekt_(540,144);
vekt_(518,168);
vekt_(521,214);
vekt_(536,241);
vekt_(602,297);
vekt_(629,350);
vekt_(650,402);
vekt_(688,439);
vekt_(728,467);
vekt_(781,466);
vekt_(826,447);
vekt_(855,422);
vekt_(898,323);
vekt_(960,343);
penup();
vekt_(0,0);
//ЧИСЛО ОТРЕЗКОВ 81
}
/////////////////////////////////
